package Exercise4 
  annotation (Coordsys(
      extent=[0, 0; 442, 394], 
      grid=[2, 2], 
      component=[20, 20]), Window(
      x=0.45, 
      y=0.01, 
      width=0.44, 
      height=0.65, 
      library=1, 
      autolayout=1));
  Pendel1 pendel1;
  Pendel2 pendel2;
  testPendel solution1;
  PendelControlled solution2;
end Exercise4;


model Pendel1 "simple pendulum with animation" 
  package SI = Modelica.SIunits;
  parameter SI.Length L=1 "length";
  parameter SI.Mass m=5 "Mass  at the mass point";
  parameter SI.Damping d=0.1 "Damping of the joint";
  annotation (
    Coordsys(
      extent=[-100, -100; 100, 100], 
      grid=[1, 1], 
      component=[20, 20]), 
    Window(
      x=0.24, 
      y=0.02, 
      width=0.64, 
      height=0.77), 
    Icon(
      Rectangle(extent=[-90, 20; 38, -20], style(color=0, fillColor=8)), 
      Ellipse(extent=[32, 34; 100, -34], style(color=0, fillColor=0)), 
      Text(extent=[-100, 100; 100, 40], string="%name"), 
      Polygon(points=[-100, -10; -120, -50; -80, -50; -100, -10], style(color=
              0, fillPattern=0)), 
      Line(points=[-120, -50; -128, -64], style(color=0)), 
      Line(points=[-108, -50; -116, -64], style(color=0)), 
      Line(points=[-96, -50; -104, -64], style(color=0)), 
      Line(points=[-83, -50; -91, -64], style(color=0))));
  ModelicaAdditions.MultiBody.Parts.InertialSystem inertialSystem annotation (
      extent=[-60, -10; -40, 10]);
  Modelica.Mechanics.Rotational.Interfaces.Flange_a flange_a annotation (
      extent=[-110, -10; -90, 10]);
  Modelica.Mechanics.Rotational.Damper damper(d=d) annotation (extent=[-36, 20
        ; -16, 40]);
  ModelicaAdditions.MultiBody.Joints.Revolute revolute annotation (extent=[-20
        , -10; 0, 10]);
  ModelicaAdditions.MultiBody.Parts.Body body(rCM={L,0,0}, m=m) annotation (
      extent=[40, -10; 60, 10]);
  ModelicaAdditions.MultiBody.Parts.Shape shape_mass(
    Shape="sphere", 
    r0={L,0,0}, 
    Length=0.1, 
    Width=0.1, 
    Height=0.1) annotation (extent=[40, -40; 60, -20]);
  ModelicaAdditions.MultiBody.Parts.Shape shape_rod(
    Shape="cylinder", 
    Length=L, 
    Width=0.05, 
    Height=0.05) annotation (extent=[12, 20; 32, 40]);
equation 
  connect(inertialSystem.frame_b, revolute.frame_a) annotation (points=[-39.5
        , 0; -20.5, 0], style(color=0, thickness=2));
  connect(revolute.axis, damper.flange_b) annotation (points=[-10, 7; -10, 20
        ; -16, 20; -16, 30]);
  connect(revolute.bearing, damper.flange_a) annotation (points=[-16, 7; -16, 
        16; -36, 16; -36, 30]);
  connect(revolute.axis, flange_a) annotation (points=[-10, 7; -10, 50; -72, 
        50; -72, 0; -100, 0]);
  connect(revolute.frame_b, body.frame_a) annotation (points=[0.5, 0; 39.5, 0]
    );
  connect(revolute.frame_b, shape_rod.frame_a) annotation (points=[0.5, 0; 6, 
        0; 6, 30; 11.5, 30]);
  connect(revolute.frame_b, shape_mass.frame_a) annotation (points=[0.5, 0; 28
        , 0; 28, -30; 39.5, -30]);
end Pendel1;


model Pendel2 
  package SI = Modelica.SIunits;
  parameter SI.Length L=1 "Length";
  parameter SI.Mass m=5 "Mass at the mass point";
  parameter SI.Damping d=0.1 "Damping at the joint";
  parameter SI.Acceleration g=9.81 "Gravitation acceleration";
  SI.Angle phi "Rotation angle of the Pendulum";
  SI.AngularVelocity w "Angle velocity of the pendulum";
  annotation (
    Coordsys(
      extent=[-100, -100; 100, 100], 
      grid=[2, 2], 
      component=[20, 20]), 
    Icon(
      Rectangle(extent=[-90, 20; 38, -20], style(color=0, fillColor=8)), 
      Ellipse(extent=[32, 34; 100, -34], style(color=0, fillColor=0)), 
      Text(extent=[-100, 100; 100, 40], string="%name"), 
      Polygon(points=[-100, -10; -120, -50; -80, -50; -100, -10], style(color=
              0, fillPattern=0)), 
      Line(points=[-120, -50; -128, -64], style(color=0)), 
      Line(points=[-108, -50; -116, -64], style(color=0)), 
      Line(points=[-96, -50; -104, -64], style(color=0)), 
      Line(points=[-83, -50; -91, -64], style(color=0))), 
    Window(
      x=0.26, 
      y=0.06, 
      width=0.6, 
      height=0.6));
  Modelica.Mechanics.Rotational.Interfaces.Flange_a flange_a annotation (
      extent=[-110, -10; -90, 10], layer="icon");
equation 
  phi = flange_a.phi;
  w = der(phi);
  m*L*L*der(w) + d*w + m*g*L*cos(phi) = flange_a.tau;
end Pendel2;


model testPendel 
  annotation (Coordsys(
      extent=[-100, -100; 100, 100], 
      grid=[2, 2], 
      component=[20, 20]), Window(
      x=0.15, 
      y=0.1, 
      width=0.71, 
      height=0.74));
  Pendel1 pendel1 annotation (extent=[-20, 40; 0, 60]);
  Pendel2 pendel2 annotation (extent=[40, 40; 60, 60]);
  Modelica.Mechanics.Rotational.Sensors.AngleSensor angleSensor1 annotation (
      extent=[-50, 8; -30, 28], rotation=-90);
  Modelica.Mechanics.Rotational.Sensors.AngleSensor angleSensor2 annotation (
      extent=[16, 8; 36, 28], rotation=-90);
  Modelica.Blocks.Math.Add difference(k1=-1) annotation (extent=[-10, -40; 10
        , -20], rotation=-90);
equation 
  connect(pendel1.flange_a, angleSensor1.flange_a) annotation (points=[-20, 50
        ; -40, 50; -40, 28]);
  connect(pendel2.flange_a, angleSensor2.flange_a) annotation (points=[40, 50
        ; 26, 50; 26, 28]);
  connect(angleSensor2.outPort, difference.inPort1) annotation (points=[26, 7
        ; 26, -8; 6, -8; 6, -18]);
  connect(angleSensor1.outPort, difference.inPort2) annotation (points=[-40, 7
        ; -40, -8; -6, -8; -6, -18]);
end testPendel;


model PendelControlled 
  annotation (Coordsys(
      extent=[-100, -100; 100, 100], 
      grid=[2, 2], 
      component=[20, 20]), Window(
      x=0.22, 
      y=0.02, 
      width=0.73, 
      height=0.82));
  Pendel1 pendel annotation (extent=[60, 40; 80, 60]);
  Modelica.Mechanics.Rotational.Torque torque annotation (extent=[20, 40; 40, 
        60]);
  Modelica.Blocks.Math.Feedback feedback annotation (extent=[-54, 40; -34, 60]
    );
  Modelica.Blocks.Math.Gain gain(k={1}) annotation (extent=[-20, 40; 0, 60]);
  Modelica.Mechanics.Rotational.Sensors.AngleSensor angleSensor annotation (
      extent=[40, 10; 60, 30], rotation=-90);
  Modelica.Blocks.Sources.Ramp ramp(height={-3.14}, duration={1}) annotation (
      extent=[-88, 40; -68, 60]);
equation 
  connect(torque.flange_b, pendel.flange_a) annotation (points=[40, 50; 60, 50
        ]);
  connect(feedback.outPort, gain.inPort) annotation (points=[-35, 50; -22, 50]
    );
  connect(pendel.flange_a, angleSensor.flange_a) annotation (points=[60, 50; 
        50, 50; 50, 30]);
  connect(angleSensor.outPort, feedback.inPort2) annotation (points=[50, 9; 50
        , 0; -44, 0; -44, 4; -44, 42]);
  connect(ramp.outPort, feedback.inPort1) annotation (points=[-67, 50; -52, 50
        ]);
  connect(gain.outPort, torque.inPort) annotation (points=[1, 50; 18, 50]);
end PendelControlled;

