package Exercise6 
  annotation (Coordsys(
      extent=[0, 0; 442, 394], 
      grid=[2, 2], 
      component=[20, 20]), Window(
      x=0.45, 
      y=0.01, 
      width=0.44, 
      height=0.65, 
      library=1, 
      autolayout=1));
  AutomaticGearbox1 solution1;
  AutomaticGearbox2 solution2;
end Exercise6;

model AutomaticGearbox
  annotation (
    Coordsys(
      extent=[-220, -40; 140, 70], 
      grid=[2, 2], 
      component=[20, 20]), 
    Window(
      x=0.24, 
      y=0, 
      width=0.72, 
      height=0.68), 
    Diagram);
public 
  Modelica.Mechanics.Rotational.IdealPlanetary planetary1(ratio=100/40) 
    annotation (extent=[-10, 0; 10, 20]);
  Modelica.Mechanics.Rotational.IdealPlanetary planetary2(ratio=100/20) 
    annotation (extent=[44, 0; 64, 20]);
  Modelica.Mechanics.Rotational.Clutch C1 annotation (extent=[-100, 40; -80, 
        60]);
  Modelica.Mechanics.Rotational.Clutch C2 annotation (extent=[-100, 0; -80, 20
        ]);
  Modelica.Mechanics.Rotational.Brake B2 annotation (extent=[-42, 0; -22, 20])
    ;
  Modelica.Mechanics.Rotational.Brake B1 annotation (extent=[18, 20; 38, 40]);
  Modelica.Mechanics.Rotational.Inertia Load(J=1) annotation (extent=[80, 0; 
        100, 20]);
  Modelica.Mechanics.Rotational.Inertia Jengine1(J=0.1) annotation (extent=[
        -130, 0; -110, 20]);
  Modelica.Mechanics.Rotational.Torque torque annotation (extent=[-164, 0; 
        -144, 20]);
  Modelica.Mechanics.Rotational.Inertia Jengine2(J=0.01) annotation (extent=[
        -70, 0; -50, 20]);
  Modelica.Blocks.Sources.Constant const(k={100}) annotation (extent=[-200, 0
        ; -180, 20]);
equation 
  connect(B2.flange_b, planetary1.sun) annotation (points=[-22, 10; -10, 10], 
      style(thickness=2));
equation 
  connect(planetary2.ring, Load.flange_a) annotation (points=[64, 10; 80, 10]
      , style(color=73, thickness=2));
equation 
  connect(Jengine1.flange_b, C2.flange_a) annotation (points=[-110, 10; -100, 
        10], style(color=73, thickness=2));
equation 
  connect(torque.flange_b, Jengine1.flange_a) annotation (points=[-144, 10; 
        -130, 10], style(color=73, thickness=2));
equation 
  connect(const.outPort, torque.inPort) annotation (points=[-179, 10; -166, 10
        ]);
equation 
  connect(C2.flange_a, C1.flange_a) annotation (points=[-100, 10; -104, 10; 
        -104, 50; -100, 50], style(color=73, thickness=2));
equation 
  connect(C2.flange_b, Jengine2.flange_a) annotation (points=[-80, 10; -70, 10
        ], style(thickness=2));
equation 
  connect(Jengine2.flange_b, B2.flange_a) annotation (points=[-50, 10; -42, 10
        ], style(thickness=2));
equation 
  connect(planetary1.carrier, planetary2.ring) annotation (points=[-10, 14; 
        -16, 14; -16, 58; 70, 58; 70, 10; 64, 10], style(color=57, thickness=2)
    );
equation 
  connect(planetary2.carrier, B1.flange_b) annotation (points=[44, 14; 38, 14
        ; 38, 30], style(thickness=2));
equation 
  connect(planetary1.sun, planetary2.sun) annotation (points=[-10, 10; -16, 10
        ; -16, -14; 38, -14; 38, 10; 44, 10], style(thickness=2));
equation 
  connect(planetary1.ring, C1.flange_b) annotation (points=[10, 10; 14, 10; 14
        , 50; -80, 50], style(thickness=2));
end AutomaticGearbox;

model AutomaticGearbox1
  annotation (
    Coordsys(
      extent=[-220, -40; 140, 70], 
      grid=[2, 2], 
      component=[20, 20]), 
    Window(
      x=0.24, 
      y=0, 
      width=0.72, 
      height=0.68), 
    Diagram);
  extends AutomaticGearbox;
  parameter Real k=2000 "Gain to produce clutch pressure force";
  parameter Real t1=1;
  parameter Real t2=3;
  parameter Real t3=6;
equation 
  if time < t1 then // gear 0
     C1.inPort.signal[1] = 0;
     C2.inPort.signal[1] = 0;
     B1.inPort.signal[1] = 0;
     B2.inPort.signal[1] = 0;
  elseif time < t2 then // gear 1
     C1.inPort.signal[1] = k;
     C2.inPort.signal[1] = 0;
     B1.inPort.signal[1] = k;
     B2.inPort.signal[1] = 0;
  elseif time < t3 then // gear 2
     C1.inPort.signal[1] = k;
     C2.inPort.signal[1] = 0;
     B1.inPort.signal[1] = 0;
     B2.inPort.signal[1] = k;
  else // gear 3
     C1.inPort.signal[1] = k;
     C2.inPort.signal[1] = k;
     B1.inPort.signal[1] = 0;
     B2.inPort.signal[1] = 0;
  end if;
end AutomaticGearbox1;

model AutomaticGearbox2 
  extends AutomaticGearbox;
  parameter Real k=2000 "Gain to produce clutch pressure force";
  parameter Real t1=1;
  parameter Real t2=3;
  parameter Real t3=6;
protected 
  parameter Real ShiftMatrix[4, 4]=[0, 0, 0, 0; 1, 0, 1, 0; 1, 0, 0, 1; 1, 1, 
      0, 0] "[Gear,Engaged]-table";
  Real ShiftState[4] "Actual state of clutches (engaged/disengaged)";
  Integer gear "Required gear";
  annotation (
    Coordsys(
      extent=[-220, -40; 140, 70], 
      grid=[2, 2], 
      component=[20, 20]), 
    Window(
      x=0.24, 
      y=0, 
      width=0.72, 
      height=0.68), 
    Diagram);
equation 
  gear = if time < t1 then 0 else if time < t2 then 1 else if time < t3 then 2
     else 3;
  
  {C1.inPort.signal[1],C2.inPort.signal[1],B1.inPort.signal[1],B2.inPort.
    signal[1]} = k*ShiftState;
  
algorithm 
  ShiftState := ShiftMatrix[gear + 1, :];
end AutomaticGearbox2;


